Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/OAIReceptionist.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/OAIReceptionist.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/OAIReceptionist.java	(revision 25635)
@@ -321,8 +321,8 @@
    *  otherwise true.
    */
-  private boolean isValidParam(HashMap param_map, HashSet valid_strs) {
-    ArrayList param_list = new ArrayList(param_map.keySet());
+  private boolean isValidParam(HashMap<String, String> param_map, HashSet<String> valid_strs) {
+    ArrayList<String> param_list = new ArrayList<String>(param_map.keySet());
     for(int i=0; i<param_list.size(); i++) {
-      if (valid_strs.contains((String)param_list.get(i)) == false) {
+      if (valid_strs.contains(param_list.get(i)) == false) {
         return false;
       }
@@ -333,5 +333,5 @@
     // option: from, until, set, metadataPrefix, resumptionToken
     // exceptions: badArgument, badResumptionToken, cannotDisseminateFormat, noRecordMatch, and noSetHierarchy
-    HashSet valid_strs = new HashSet();
+    HashSet<String> valid_strs = new HashSet<String>();
     valid_strs.add(OAIXML.FROM);
     valid_strs.add(OAIXML.UNTIL);
@@ -347,5 +347,5 @@
     String token = "";
     
-    HashMap param_map = OAIXML.getParamMap(params);    
+    HashMap<String, String> param_map = OAIXML.getParamMap(params);    
     if (!isValidParam(param_map, valid_strs)) {
 	logger.error("One of the params is invalid");
@@ -353,5 +353,5 @@
     } 
     // param keys are valid, but if there are any date params, check they're of the right format
-    String from = (String)param_map.get(OAIXML.FROM);
+    String from = param_map.get(OAIXML.FROM);
     if(from != null) {	
 	Date from_date = OAIXML.getDate(from);
@@ -361,5 +361,5 @@
 	}
     }
-    String until = (String)param_map.get(OAIXML.UNTIL);
+    String until = param_map.get(OAIXML.UNTIL);
     if(until != null) {	
 	Date until_date = OAIXML.getDate(until);
@@ -389,5 +389,5 @@
     if(request_set == true) {
       boolean set_supported = false;
-      String set_spec_str = (String)param_map.get(OAIXML.SET);
+      String set_spec_str = param_map.get(OAIXML.SET);
       // get the collection name
       //if setSpec is supported by this repository, it must be in the form: site_name:coll_name
@@ -409,5 +409,5 @@
     if(param_map.containsKey(OAIXML.RESUMPTION_TOKEN)) {
         // validate resumptionToken
-      token = (String)param_map.get(OAIXML.RESUMPTION_TOKEN);
+      token = param_map.get(OAIXML.RESUMPTION_TOKEN);
       logger.info("has resumptionToken" + token);
       if(OAIXML.containsToken(token) == false) {
@@ -424,5 +424,5 @@
     
     //Now that we got a prefix, check and see if it's supported by this repository
-    String prefix_value = (String)param_map.get(OAIXML.METADATA_PREFIX);
+    String prefix_value = param_map.get(OAIXML.METADATA_PREFIX);
     if (containsMetadataPrefix(prefix_value) == false) {
       logger.error("requested prefix is not found in OAIConfig.xml");
@@ -434,5 +434,5 @@
     String verb = req.getAttribute(OAIXML.TO); 
     NodeList param_list = req.getElementsByTagName(OAIXML.PARAM);
-    ArrayList retain_param_list = new ArrayList();
+    ArrayList<Element> retain_param_list = new ArrayList<Element>();
     for (int j=0; j<param_list.getLength(); j++) {
       Element e = OAIXML.duplicateElement(msg.getOwnerDocument(), (Element)param_list.item(j), true);
@@ -449,5 +449,5 @@
           msg.appendChild(req);
           for (int j=0; j<retain_param_list.size(); j++) {
-            req.appendChild((Element)retain_param_list.get(j));
+            req.appendChild(retain_param_list.get(j));
           }
         }
@@ -538,5 +538,5 @@
     // option: from, until, set, metadataPrefix, and resumptionToken
     // exceptions: badArgument, badResumptionToken, cannotDisseminateFormat, noRecordMatch, and noSetHierarchy
-    HashSet valid_strs = new HashSet();
+    HashSet<String> valid_strs = new HashSet<String>();
     valid_strs.add(OAIXML.FROM);
     valid_strs.add(OAIXML.UNTIL);
@@ -558,5 +558,5 @@
     }
     
-    HashMap param_map = OAIXML.getParamMap(params);    
+    HashMap<String, String> param_map = OAIXML.getParamMap(params);    
     if (!isValidParam(param_map, valid_strs)) {
 	logger.error("One of the params is invalid");
@@ -564,5 +564,5 @@
     }
     // param keys are valid, but if there are any date params, check they're of the right format
-    String from = (String)param_map.get(OAIXML.FROM);
+    String from = param_map.get(OAIXML.FROM);
     if(from != null) {	
 	Date from_date = OAIXML.getDate(from);
@@ -572,5 +572,5 @@
 	}
     }
-    String until = (String)param_map.get(OAIXML.UNTIL);
+    String until = param_map.get(OAIXML.UNTIL);
     Date until_date = null;
     if(until != null) {	
@@ -601,5 +601,5 @@
     if(request_set == true) {
       boolean set_supported = false;
-      String set_spec_str = (String)param_map.get(OAIXML.SET);
+      String set_spec_str = param_map.get(OAIXML.SET);
       // get the collection name
       //if setSpec is supported by this repository, it must be in the form: site_name:coll_name
@@ -630,5 +630,5 @@
       //    store a new token if necessary.
         //}      
-      token = (String)param_map.get(OAIXML.RESUMPTION_TOKEN);
+      token = param_map.get(OAIXML.RESUMPTION_TOKEN);
       logger.info("has resumptionToken: " + token);
       if(OAIXML.containsToken(token) == false) {
@@ -671,5 +671,5 @@
     
     //Now that we got a prefix, check and see if it's supported by this repository
-    String prefix_value = (String)param_map.get(OAIXML.METADATA_PREFIX);
+    String prefix_value = param_map.get(OAIXML.METADATA_PREFIX);
     if (containsMetadataPrefix(prefix_value) == false) {
 	logger.error("requested prefix is not found in OAIConfig.xml");
@@ -682,5 +682,5 @@
     String verb = req.getAttribute(OAIXML.TO); 
     NodeList param_list = req.getElementsByTagName(OAIXML.PARAM);
-    ArrayList retain_param_list = new ArrayList();
+    ArrayList<Element> retain_param_list = new ArrayList<Element>();
     for (int j=0; j<param_list.getLength(); j++) {
       Element e = OAIXML.duplicateElement(msg.getOwnerDocument(), (Element)param_list.item(j), true);
@@ -698,5 +698,5 @@
           msg.appendChild(req);
           for (int j=0; j<retain_param_list.size(); j++) {
-            req.appendChild((Element)retain_param_list.get(j));
+            req.appendChild(retain_param_list.get(j));
           }
         }
@@ -747,5 +747,5 @@
       getRecords(list_records, record_list, 0, resume_after);
       //An incomplete list is sent; append a resumptionToken element
-      Element token_elem = createResumptionTokenElement(num_records, 0, resume_after, true, (String)param_map.get(OAIXML.METADATA_PREFIX));
+      Element token_elem = createResumptionTokenElement(num_records, 0, resume_after, true, param_map.get(OAIXML.METADATA_PREFIX));
       //store this token
       OAIXML.addToken(token_elem);
@@ -768,5 +768,5 @@
         getRecords(list_records, record_list, cursor, num_records);
         //An incomplete list is sent; append a resumptionToken element
-	token_elem = createResumptionTokenElement(num_records, cursor, -1, false, (String)param_map.get(OAIXML.METADATA_PREFIX));
+	token_elem = createResumptionTokenElement(num_records, cursor, -1, false, param_map.get(OAIXML.METADATA_PREFIX));
 	list_records.appendChild(token_elem);
 
@@ -775,5 +775,5 @@
         //append required records to list_records (list is incomplete)
         getRecords(list_records, record_list, cursor, cursor + resume_after);
-        token_elem = createResumptionTokenElement(num_records, cursor, cursor + resume_after, true, (String)param_map.get(OAIXML.METADATA_PREFIX));
+        token_elem = createResumptionTokenElement(num_records, cursor, cursor + resume_after, true, param_map.get(OAIXML.METADATA_PREFIX));
         //store this token
         OAIXML.addToken(token_elem);
@@ -1013,5 +1013,5 @@
     Element get_record = OAIXML.createElement(OAIXML.GET_RECORD);
 
-    HashSet valid_strs = new HashSet();
+    HashSet<String> valid_strs = new HashSet<String>();
     valid_strs.add(OAIXML.IDENTIFIER);
     valid_strs.add(OAIXML.METADATA_PREFIX);
@@ -1019,5 +1019,5 @@
     Element req = (Element)GSXML.getChildByTagName(msg, GSXML.REQUEST_ELEM);
     NodeList params = GSXML.getChildrenByTagName(req, OAIXML.PARAM);
-    HashMap param_map = OAIXML.getParamMap(params);    
+    HashMap<String, String> param_map = OAIXML.getParamMap(params);    
     
     if(!isValidParam(param_map, valid_strs) ||
@@ -1029,6 +1029,6 @@
     }
     
-    String prefix = (String)param_map.get(OAIXML.METADATA_PREFIX);
-    String identifier = (String)param_map.get(OAIXML.IDENTIFIER);
+    String prefix = param_map.get(OAIXML.METADATA_PREFIX);
+    String identifier = param_map.get(OAIXML.IDENTIFIER);
     
     // verify the metadata prefix
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/Page.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/Page.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/Page.java	(revision 25635)
@@ -2,4 +2,5 @@
 
 import java.io.File;
+import java.io.Serializable;
 import java.util.HashMap;
 
@@ -127,5 +128,5 @@
 		Element cgi_param_list = (Element)GSXML.getChildByTagName(request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
 		if (cgi_param_list != null) {
-			HashMap params = GSXML.extractParams(cgi_param_list, false);
+			HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 			collection = (String)params.get(GSParams.COLLECTION);
 			if (collection == null) collection = "";
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/Receptionist.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/Receptionist.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/Receptionist.java	(revision 25635)
@@ -31,5 +31,5 @@
 
 	/** the set up variables */
-	protected HashMap config_params = null;
+	protected HashMap<String, Comparable> config_params = null;
 	/** container Document to create XML Nodes */
 	protected Document doc = null;
@@ -42,5 +42,5 @@
 
 	/** the list of actions */
-	protected HashMap action_map = null;
+	protected HashMap<String, Action> action_map = null;
 
 	/** the list of params */
@@ -49,5 +49,5 @@
 
 	/** the list of interfaces this is based on */
-	protected ArrayList base_interfaces = null;
+	protected ArrayList<String> base_interfaces = null;
 
 	public Receptionist()
@@ -55,5 +55,5 @@
 		this.converter = new XMLConverter();
 		this.doc = this.converter.newDOM();
-		this.action_map = new HashMap();
+		this.action_map = new HashMap<String, Action>();
 	}
 
@@ -67,10 +67,10 @@
 	}
 
-	public void setConfigParams(HashMap params)
+	public void setConfigParams(HashMap<String, Comparable> params)
 	{
 		this.config_params = params;
 	}
 
-	public HashMap getConfigParams()
+	public HashMap<String, Comparable> getConfigParams()
 	{
 		return this.config_params;
@@ -211,5 +211,5 @@
 
 		// find the  appropriate action	
-		Action a = (Action) this.action_map.get(action);
+		Action a = this.action_map.get(action);
 
 		String action_name = null;
@@ -313,5 +313,5 @@
 			if (base_interfaces == null)
 			{
-				base_interfaces = new ArrayList();
+				base_interfaces = new ArrayList<String>();
 			}
 			base_interfaces.add(base_interface);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java	(revision 25635)
@@ -17,4 +17,5 @@
 import java.io.ByteArrayInputStream;
 import java.io.File;
+import java.io.Serializable;
 import java.io.StringReader;
 import java.io.StringWriter;
@@ -53,5 +54,5 @@
 
 	/** the list of xslt to use for actions */
-	protected HashMap xslt_map = null;
+	protected HashMap<String, String> xslt_map = null;
 
 	/** a transformer class to transform xml using xslt */
@@ -64,5 +65,5 @@
 	{
 		super();
-		this.xslt_map = new HashMap();
+		this.xslt_map = new HashMap<String, String>();
 		this.transformer = new XMLTransformer();
 		try
@@ -197,5 +198,5 @@
 		if (cgi_param_list != null)
 		{
-			HashMap params = GSXML.extractParams(cgi_param_list, false);
+			HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 			if ((excerptID = (String) params.get(GSParams.EXCERPT_ID)) != null)
 			{
@@ -461,5 +462,5 @@
 		{
 			// Don't waste time getting all the parameters
-			HashMap params = GSXML.extractParams(cgi_param_list, false);
+			HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 			collection = (String) params.get(GSParams.COLLECTION);
 			if (collection == null)
@@ -883,10 +884,10 @@
 		{
 			String key = action + ":" + subaction;
-			name = (String) this.xslt_map.get(key);
+			name = this.xslt_map.get(key);
 		}
 		// try the action by itself
 		if (name == null)
 		{
-			name = (String) this.xslt_map.get(action);
+			name = this.xslt_map.get(action);
 		}
 		// now find the absolute path
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/selfContained/FilesDocumentStream.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/selfContained/FilesDocumentStream.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/selfContained/FilesDocumentStream.java	(revision 25635)
@@ -54,7 +54,7 @@
   implements DocumentStream {
   /** the files we've found so far */
-  Vector files = new Vector();
+  Vector<String> files = new Vector<String>();
   /** the directories we've found so far */
-  Vector directories = new Vector();
+  Vector<String> directories = new Vector<String>();
 
   /**
@@ -111,5 +111,5 @@
   protected void expandIfNecessary() {
     while (directories.size() > 0) {
-      String dirname = (String) directories.elementAt(0);
+      String dirname = directories.elementAt(0);
       directories.removeElement(dirname);
       File dir = new File(dirname);
@@ -144,5 +144,5 @@
     if (!hasNextDocument()) throw new Error("Doesn't have another Document");
 
-    String filename = (String) files.elementAt(files.size() - 1);
+    String filename = files.elementAt(files.size() - 1);
     files.removeElementAt(files.size() - 1);
     File file = new File(filename);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractBrowse.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractBrowse.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractBrowse.java	(revision 25635)
@@ -340,5 +340,5 @@
 	boolean want_info = false;
 
-	ArrayList info_types=new ArrayList();
+	ArrayList<String> info_types=new ArrayList<String>();
 	// The document structure information desired
 	boolean want_ancestors = false;
@@ -416,5 +416,5 @@
 		
 		for (int j=0; j<info_types.size(); j++) {
-		    String info_type = (String)info_types.get(j);
+		    String info_type = info_types.get(j);
 		    String info_value = getStructureInfo(node_id, info_type);
 		    if (info_value != null) {
@@ -511,5 +511,5 @@
 
 	// The metadata information required
-	ArrayList metadata_names_list = new ArrayList();
+	ArrayList<String> metadata_names_list = new ArrayList<String>();
 	boolean all_metadata = false;
 	// Process the request parameters
@@ -619,8 +619,8 @@
 				  boolean recursive)
     {
-	ArrayList child_ids = getChildrenIds(node_id);
+	ArrayList<String> child_ids = getChildrenIds(node_id);
 	if (child_ids==null) return;
 	for (int i=0; i< child_ids.size(); i++) {
-	    String child_id = (String)child_ids.get(i);
+	    String child_id = child_ids.get(i);
 	    Element child_elem;
 	    if (isDocumentId(child_id)) {
@@ -675,5 +675,5 @@
 
     /** returns the list of sibling ids, including the specified node_id */
-    protected ArrayList getSiblingIds(String node_id) {
+    protected ArrayList<String> getSiblingIds(String node_id) {
 	String parent_id = getParentId(node_id);
 	if (parent_id == null) {
@@ -698,5 +698,5 @@
     abstract protected String getRootId(String node_id);
     /** returns a list of the child ids in order, null if no children */
-    abstract protected ArrayList getChildrenIds(String node_id);
+    abstract protected ArrayList<String> getChildrenIds(String node_id);
     /** returns the node id of the parent node, null if no parent */
     abstract protected String getParentId(String node_id);
@@ -715,5 +715,5 @@
     abstract protected Element getMetadataList(String node_id,
 					       boolean all_metadata,
-					       ArrayList metadata_names);
+					       ArrayList<String> metadata_names);
 
     /** get the particular metadata (identified by the metadata name) for the classifier node node_id
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractDocumentRetrieve.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractDocumentRetrieve.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractDocumentRetrieve.java	(revision 25635)
@@ -205,5 +205,5 @@
 
 		// The metadata information required
-		ArrayList metadata_names_list = new ArrayList();
+		ArrayList<String> metadata_names_list = new ArrayList<String>();
 		boolean all_metadata = false;
 		// Process the request parameters
@@ -353,5 +353,5 @@
 		boolean want_info = false;
 
-		ArrayList info_types = new ArrayList();
+		ArrayList<String> info_types = new ArrayList<String>();
 		// The document structure information desired
 		boolean want_ancestors = false;
@@ -440,5 +440,5 @@
 				for (int j = 0; j < info_types.size(); j++)
 				{
-					String info_type = (String) info_types.get(j);
+					String info_type = info_types.get(j);
 					String info_value = getStructureInfo(doc_id, info_type);
 					if (info_value != null)
@@ -654,10 +654,10 @@
 	protected void addDescendants(Element doc, String doc_id, boolean recursive)
 	{
-		ArrayList child_ids = getChildrenIds(doc_id);
+		ArrayList<String> child_ids = getChildrenIds(doc_id);
 		if (child_ids == null)
 			return;
 		for (int i = 0; i < child_ids.size(); i++)
 		{
-			String child_id = (String) child_ids.get(i);
+			String child_id = child_ids.get(i);
 			Element child_elem = createDocNode(child_id);
 			doc.appendChild(child_elem);
@@ -707,5 +707,5 @@
 
 	/** returns the list of sibling ids, including the specified node_id */
-	protected ArrayList getSiblingIds(String node_id)
+	protected ArrayList<String> getSiblingIds(String node_id)
 	{
 		String parent_id = getParentId(node_id);
@@ -803,5 +803,5 @@
 	 * implementation: return null
 	 */
-	protected ArrayList getChildrenIds(String node_id)
+	protected ArrayList<String> getChildrenIds(String node_id)
 	{
 		return null;
@@ -821,5 +821,5 @@
 	 * <metadataList><metadata name="xxx">value</metadata></metadataList>
 	 */
-	abstract protected Element getMetadataList(String doc_id, boolean all_metadata, ArrayList metadata_names) throws GSException;
+	abstract protected Element getMetadataList(String doc_id, boolean all_metadata, ArrayList<String> metadata_names) throws GSException;
 
 	/**
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2DocumentRetrieve.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2DocumentRetrieve.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2DocumentRetrieve.java	(revision 25635)
@@ -157,5 +157,5 @@
 
 	/** returns a list of the child ids in order, null if no children */
-	protected ArrayList getChildrenIds(String node_id)
+	protected ArrayList<String> getChildrenIds(String node_id)
 	{
 		DBInfo info = this.coll_db.getInfo(node_id);
@@ -170,5 +170,5 @@
 			return null;
 		}
-		ArrayList children = new ArrayList();
+		ArrayList<String> children = new ArrayList<String>();
 		StringTokenizer st = new StringTokenizer(contains, ";");
 		while (st.hasMoreTokens())
@@ -198,5 +198,5 @@
 	 */
 	// assumes only one value per metadata
-	protected Element getMetadataList(String node_id, boolean all_metadata, ArrayList metadata_names) throws GSException
+	protected Element getMetadataList(String node_id, boolean all_metadata, ArrayList<String> metadata_names) throws GSException
 	{
 		Element metadata_list = this.doc.createElement(GSXML.METADATA_ELEM + GSXML.LIST_MODIFIER);
@@ -210,14 +210,14 @@
 		{
 			// return everything out of the database
-			Set keys = info.getKeys();
-			Iterator it = keys.iterator();
+			Set<String> keys = info.getKeys();
+			Iterator<String> it = keys.iterator();
 			while (it.hasNext())
 			{
-				String key = (String) it.next();
+				String key = it.next();
 				//String value = info.getInfo(key);
-				Vector values = info.getMultiInfo(key);
+				Vector<String> values = info.getMultiInfo(key);
 				for (int i = 0; i < values.size(); i++)
 				{
-					GSXML.addMetadata(this.doc, metadata_list, key, this.macro_resolver.resolve((String) values.elementAt(i), lang, MacroResolver.SCOPE_META, node_id));
+					GSXML.addMetadata(this.doc, metadata_list, key, this.macro_resolver.resolve(values.elementAt(i), lang, MacroResolver.SCOPE_META, node_id));
 				}
 			}
@@ -228,5 +228,5 @@
 			for (int i = 0; i < metadata_names.size(); i++)
 			{
-				String meta_name = (String) metadata_names.get(i);
+				String meta_name = metadata_names.get(i);
 				String value = getMetadata(node_id, info, meta_name, lang);
 				GSXML.addMetadata(this.doc, metadata_list, meta_name, value);
@@ -375,5 +375,5 @@
 		if (pos == -1)
 		{
-			Vector values = info.getMultiInfo(metadata);
+			Vector<String> values = info.getMultiInfo(metadata);
 			if (values != null)
 			{
@@ -391,5 +391,5 @@
 						result.append(separator);
 					}
-					result.append(this.macro_resolver.resolve((String) values.elementAt(i), lang, MacroResolver.SCOPE_META, node_id));
+					result.append(this.macro_resolver.resolve(values.elementAt(i), lang, MacroResolver.SCOPE_META, node_id));
 				}
 				return result.toString();
@@ -482,5 +482,5 @@
 		{
 			// we have multiple meta
-			Vector values = relation_info.getMultiInfo(metadata);
+			Vector<String> values = relation_info.getMultiInfo(metadata);
 			if (values != null)
 			{
@@ -496,5 +496,5 @@
 						result.append(separator);
 					}
-					result.append(this.macro_resolver.resolve((String) values.elementAt(i), lang, MacroResolver.SCOPE_META, relation_id));
+					result.append(this.macro_resolver.resolve(values.elementAt(i), lang, MacroResolver.SCOPE_META, relation_id));
 				}
 			}
@@ -522,5 +522,5 @@
 			else
 			{
-				Vector values = relation_info.getMultiInfo(metadata);
+				Vector<String> values = relation_info.getMultiInfo(metadata);
 				if (values != null)
 				{
@@ -528,5 +528,5 @@
 					{
 						result.insert(0, separator);
-						result.insert(0, this.macro_resolver.resolve((String) values.elementAt(i), lang, MacroResolver.SCOPE_META, relation_id));
+						result.insert(0, this.macro_resolver.resolve(values.elementAt(i), lang, MacroResolver.SCOPE_META, relation_id));
 					}
 				}
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2FieldSearch.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2FieldSearch.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2FieldSearch.java	(revision 25635)
@@ -34,4 +34,5 @@
 import java.util.Vector;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -391,6 +392,6 @@
 		if (name.equals(LEVEL_PARAM))
 		{
-			ArrayList level_ids = new ArrayList();
-			ArrayList level_names = new ArrayList();
+			ArrayList<String> level_ids = new ArrayList<String>();
+			ArrayList<String> level_names = new ArrayList<String>();
 			getLevelData(level_ids, level_names, lang);
 			if (level_ids.size() > 1)
@@ -429,6 +430,6 @@
 		else if (name.equals(FIELD_FIELD_PARAM))
 		{
-			ArrayList fields = new ArrayList();
-			ArrayList field_names = new ArrayList();
+			ArrayList<String> fields = new ArrayList<String>();
+			ArrayList<String> field_names = new ArrayList<String>();
 			getIndexData(fields, field_names, lang);
 			// the field list -  read from config file
@@ -438,5 +439,5 @@
 			// Changed from:
 			// param = GSXML.createParameterDescription2(this.doc, name, getTextString("param."+name, lang), GSXML.PARAM_TYPE_ENUM_SINGLE, (String)fields.get(0), fields, field_names );
-			String default_value = (fields.size() > 0) ? (String) fields.get(0) : null;
+			String default_value = (fields.size() > 0) ? fields.get(0) : null;
 			// don't want to access element 0 if fields.size()==0, and
 			// GSXML.createParameterDescription2 checks for default_value==null condition
@@ -465,5 +466,5 @@
 
 	// should cache some of this
-	protected void getLevelData(ArrayList level_ids, ArrayList level_names, String lang)
+	protected void getLevelData(ArrayList<String> level_ids, ArrayList<String> level_names, String lang)
 	{
 		Element level_list = (Element) GSXML.getChildByTagName(this.config_info, LEVEL_ELEM + GSXML.LIST_MODIFIER);
@@ -565,5 +566,5 @@
 
 		// Process the request parameters
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		// Make sure a query has been specified
@@ -658,5 +659,5 @@
 	/** methods to handle actually doing the query */
 	/** do any initialisation of the query object */
-	abstract protected boolean setUpQueryer(HashMap params);
+	abstract protected boolean setUpQueryer(HashMap<String, Serializable> params);
 
 	/** do the query */
@@ -673,5 +674,5 @@
 
 	/** add in term info if available */
-	abstract protected boolean addTermInfo(Element term_list, HashMap params, Object query_result);
+	abstract protected boolean addTermInfo(Element term_list, HashMap<String, Serializable> params, Object query_result);
 
 	/**
@@ -680,5 +681,5 @@
 	 */
 	/** We assume the combination (AND/OR) is done by the match param */
-	protected String parseFieldQueryParams(HashMap params)
+	protected String parseFieldQueryParams(HashMap<String, Serializable> params)
 	{
 
@@ -707,5 +708,5 @@
 	 * query
 	 */
-	protected String parseAdvancedFieldQueryParams(HashMap params)
+	protected String parseAdvancedFieldQueryParams(HashMap<String, Serializable> params)
 	{
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2TextSearch.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2TextSearch.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2TextSearch.java	(revision 25635)
@@ -227,5 +227,5 @@
 	}
 
-	protected void getIndexData(ArrayList index_ids, ArrayList index_names, String lang)
+	protected void getIndexData(ArrayList<String> index_ids, ArrayList<String> index_names, String lang)
 	{
 		// the index info -
@@ -256,5 +256,5 @@
 	}
 
-	protected void getIndexSubcollectionData(ArrayList index_sub_ids, ArrayList index_sub_names, String lang)
+	protected void getIndexSubcollectionData(ArrayList<String> index_sub_ids, ArrayList<String> index_sub_names, String lang)
 	{
 		// the index info -
@@ -285,5 +285,5 @@
 	}
 
-	protected void getIndexLanguageData(ArrayList index_lang_ids, ArrayList index_lang_names, String lang)
+	protected void getIndexLanguageData(ArrayList<String> index_lang_ids, ArrayList<String> index_lang_names, String lang)
 	{
 		// the index info -
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractSearch.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractSearch.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractSearch.java	(revision 25635)
@@ -288,6 +288,6 @@
 		{
 			// should we make these class fields?
-			ArrayList index_ids = new ArrayList();
-			ArrayList index_names = new ArrayList();
+			ArrayList<String> index_ids = new ArrayList<String>();
+			ArrayList<String> index_names = new ArrayList<String>();
 			getIndexData(index_ids, index_names, lang);
 			String param_type = GSXML.PARAM_TYPE_ENUM_SINGLE;
@@ -389,5 +389,5 @@
 	 * subclass there must be at least one index
 	 */
-	abstract protected void getIndexData(ArrayList index_ids, ArrayList index_names, String lang);
+	abstract protected void getIndexData(ArrayList<String> index_ids, ArrayList<String> index_names, String lang);
 
 }
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractTextSearch.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractTextSearch.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractTextSearch.java	(revision 25635)
@@ -105,6 +105,6 @@
 	    Element index_sub_list = (Element)GSXML.getChildByTagName(this.config_info, INDEX_SUBCOLLECTION_ELEM+GSXML.LIST_MODIFIER);
 	    if (index_sub_list == null) return true; // processed, just not a very interesting result
-	    ArrayList index_sub_ids = new ArrayList();
-	    ArrayList index_sub_names = new ArrayList();
+	    ArrayList<String> index_sub_ids = new ArrayList<String>();
+	    ArrayList<String> index_sub_names = new ArrayList<String>();
 	    getIndexSubcollectionData(index_sub_ids, index_sub_names, lang);
 	    String param_type = GSXML.PARAM_TYPE_ENUM_SINGLE;
@@ -122,6 +122,6 @@
 	    Element index_lang_list = (Element)GSXML.getChildByTagName(this.config_info, INDEX_LANGUAGE_ELEM+GSXML.LIST_MODIFIER);
             if (index_lang_list == null) return true; // processed, just not a very interesting result
-	    ArrayList index_lang_ids = new ArrayList();
-	    ArrayList index_lang_names = new ArrayList();
+	    ArrayList<String> index_lang_ids = new ArrayList<String>();
+	    ArrayList<String> index_lang_names = new ArrayList<String>();
 	    getIndexLanguageData(index_lang_ids, index_lang_names, lang);
 	    String param_type = GSXML.PARAM_TYPE_ENUM_SINGLE;
@@ -150,10 +150,10 @@
      * might be implemented by subclass
      */
-    protected void getIndexSubcollectionData(ArrayList index_ids, ArrayList index_names, String lang){}
+    protected void getIndexSubcollectionData(ArrayList<String> index_ids, ArrayList<String> index_names, String lang){}
     
     /** get the details about the indexes available
      * might be implemented by subclass
      */
-    protected void getIndexLanguageData(ArrayList index_ids, ArrayList index_names, String lang){}
+    protected void getIndexLanguageData(ArrayList<String> index_ids, ArrayList<String> index_names, String lang){}
   
 
